SystemOrganization addCategory: #'LizViz-Traits'!

Trait named: #TZzAddFirstOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddFirstOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 18:43:55.366'!
add: anItemValue
	
	^ self addFirst: anItemValue! !

!TZzAddFirstOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/10/2013 22:02:10.905'!
addFirst: anItemValue
	
	| newItem |
	newItem := ZzDoubleLinkedListItem new
		owner: self;
		nextItem: self firstItem;
		previousItem: nil;
		value: anItemValue.
	self
		firstItem: newItem;
		itemAddedFirst: newItem.
	self firstItem nextItem ifNotNilDo: [:item | 
		(item respondsTo: #previousItem) ifTrue: [item previousItem: newItem]].
	^ newItem! !

!TZzAddFirstOperation methodsFor: 'signals' stamp: 'ls 6/10/2013 21:07:23.471'!
itemAddedFirst: anItem
	
	self log: (ZzVisualizationEvent new
		type: #itemAddedFirst:;
		parameter1: anItem).! !

Trait named: #TZzAddLastOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddLastOperation methodsFor: 'as yet unclassified' stamp: 'ls 6/10/2013 21:05:47.072'!
addLast: anItemValue
	
	| lastItem newItem |
	newItem := ZzDoubleLinkedListItem new
		owner: self;
		nextItem: nil;
		previousItem: nil;
		value: anItemValue.
	
	self firstItem ifNil: [self firstItem: newItem. ^ newItem].
	
	lastItem := self firstItem.
	[lastItem isNil not and: [lastItem nextItem isNil not]]
		whileTrue: [lastItem := lastItem nextItem].
	newItem previousItem: lastItem.
	lastItem nextItem: newItem.
	^ newItem! !

Trait named: #TZzIsEmptyOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzIsEmptyOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 19:48:15.168'!
isEmpty
	
	^ self firstItem isNil! !

Trait named: #TZzPopOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzPopOperation methodsFor: 'as yet unclassified' stamp: 'ls 6/10/2013 21:06:27.347'!
pop

	| item |
	self firstItem isNil ifTrue: [^ nil].
	item := self firstItem.
	self firstItem: self firstItem nextItem.
	^ item! !

Trait named: #TZzPushOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzPushOperation methodsFor: 'as yet unclassified' stamp: 'ls 6/10/2013 21:06:20.235'!
push: aValue

	| newItem |
	newItem := ZzListItem new
		owner: self;
		nextItem: self firstItem;
		value: aValue.
	self firstItem: newItem.! !

Trait named: #TZzRemoveFirstOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzRemoveFirstOperation methodsFor: 'signals' stamp: 'or 6/7/2013 19:12:00.953'!
itemRemoved: anItem

	self emit.! !

!TZzRemoveFirstOperation methodsFor: 'as yet unclassified' stamp: 'or 6/7/2013 21:15:43.821'!
removeFirst

	self firstItem ifNil: [^ self].
	self itemRemoved: self firstItem.
	self firstItem: self firstItem nextItem.
	(self firstItem respondsTo: #previousItem) ifTrue: [self firstItem previousItem: nil].! !

Trait named: #TZzRemoveLastOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzRemoveLastOperation methodsFor: 'as yet unclassified' stamp: 'ls 6/5/2013 22:14:25.398'!
removeLast
	
	| lastItem |
	self firstItem ifNil: [^ self].
	
	lastItem := self firstItem.
	(lastItem isNil not and: [lastItem nextItem isNil not])
		whileTrue: [lastItem := lastItem nextItem].
	lastItem previousItem nextItem: nil.! !

Trait named: #TZzSizeOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzSizeOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 19:24:11.643'!
size
	
	| size nextItem |
	size := 0.
	nextItem := self firstItem.
	nextItem isNil not whileTrue: 
		[size := size + 1.
		nextItem := nextItem nextItem].
	^ size! !
